package generated.ageVerification.javacard.ePa;

import javacard.framework.*;

import once.ageVerification.javacard.*;

/**
 * Generated Smartcard for ageVerification model
 */
public class EPa extends SimpleComm {

	public PrivateKey ownPrivkey;
	public PublicKey trustedPukey;
	public byte[] Name;
	public byte[] answer;
	public Nonce challenge;
	public Certificate TCert;
	public Date dateOfBirth;
	public Certificate EPaCert;
	public byte State;

	/**
	 * Constructor
	 */
	public EPa() {
		ownPrivkey = new PrivateKey();
		trustedPukey = new PublicKey();
		Name = new byte[Store.LENGTHOFSTRING];
		answer = new byte[Store.LENGTHOFSTRING];
		challenge = new Nonce();
		TCert = new Certificate();
		dateOfBirth = new Date();
		EPaCert = new Certificate();
		State = Status.APPLET_UNINITIALIZED;
	}

	public void appletInitialization(byte[] buf, short offset) {
		if (State != Status.APPLET_UNINITIALIZED)
			stop();
		Coding.getInstance().decodeEPa(buf, offset, this);
	}

	/**
	 * This init method is used for testcases to quickly initialize a card
	 */
	public EPa init(Certificate EPaCert, byte[] Name, byte State,
			byte[] answer, Date dateOfBirth, PrivateKey ownPrivkey,
			PublicKey trustedPukey) {

		this.EPaCert = EPaCert;
		this.Name = Name;
		this.State = State;
		this.answer = answer;
		this.dateOfBirth = dateOfBirth;
		this.ownPrivkey = ownPrivkey;
		this.trustedPukey = trustedPukey;

		challenge = new Nonce();
		TCert = new Certificate();

		return this;
	}

	public EPa init() {
		ownPrivkey = new PrivateKey();
		trustedPukey = new PublicKey();
		Name = new byte[Store.LENGTHOFSTRING];
		answer = new byte[Store.LENGTHOFSTRING];
		challenge = new Nonce();
		TCert = new Certificate();
		dateOfBirth = new Date();
		EPaCert = new Certificate();
		State = Status.IDLE;

		return this;
	}

	/**
	 * process-method, is called from SimpleComm when a message arrives
	 * 
	 * @param inmsg message to process
	 */
	public void process(Message inmsg) {
		if (State == Status.APPLET_UNINITIALIZED)
			stop();

		currentGate.callConstraints();

		switch (inmsg.getCode()) {
			case Code.SENDCERT :
				processSendCert((sendCert) inmsg);
				break;
			case Code.SIG :
				processSig((sig) inmsg);
				break;
			//Unknown Message
			default :
				stop();
		}

		currentGate.callConstraints();
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processSendCert(sendCert inmsg) {
		Nonce challenge = inmsg.Nonce1;
		Certificate termcert = inmsg.TCert;
		boolean valid = SignedData.verify(trustedPukey, termcert.sig,
				termcert.data);
		if (valid == true) {
			TCert.copy(termcert);
			challenge = Nonce.generateNonce();
			sendMsg(Store.newsendNonce(challenge));
		} else {
			stop();
		}
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processSig(sig inmsg) {
		SigData temp = inmsg.data;
		SignedData signedData = inmsg.sig;
		boolean val = SignedData.verify(TCert.data.PublicKey, signedData, temp);
		if (val == true) {
			boolean ok = Calendar.compareAge(dateOfBirth, temp.Datum, temp.age);
			if (ok) {
				SigBackData tp = Store.newSigBackData(temp.Nonce1, temp.Nonce2,
						temp.age, answer);
				SignedData signedData2 = SignedData.sign(ownPrivkey, tp);
				sendMsg(Store.newsigBack(tp, signedData2, EPaCert));
			} else {
				stop();
			}
		} else {
			stop();
		}
	}

}
