package generated.ageVerification.javacard.ePa;

import javacard.security.RSAPublicKey;
import javacard.security.KeyBuilder;

public class PublicKey extends Key implements Codeable, SignData {

	public final static short MODULUSLENGTH = 128;
	public final static short EXPONENTLENGTH = 3;

	private RSAPublicKey apikey;

	public byte[] modulus;
	public byte[] pubexponent = {0x01, 0x00, 0x01};

	private static final byte[] defaultModulus = new byte[]{(byte) 0x95,
			(byte) 0x5D, (byte) 0x7D, (byte) 0x9F, (byte) 0xEB, (byte) 0x31,
			(byte) 0xFF, (byte) 0xBD, (byte) 0xBE, (byte) 0x0C, (byte) 0x1C,
			(byte) 0x5B, (byte) 0x53, (byte) 0x37, (byte) 0x1B, (byte) 0xBB,
			(byte) 0xDB, (byte) 0xFB, (byte) 0x7D, (byte) 0x83, (byte) 0x07,
			(byte) 0x41, (byte) 0x73, (byte) 0xE1, (byte) 0xDA, (byte) 0x82,
			(byte) 0x2F, (byte) 0x7A, (byte) 0xB6, (byte) 0x7B, (byte) 0xC9,
			(byte) 0x5D, (byte) 0x16, (byte) 0x52, (byte) 0xAE, (byte) 0xCD,
			(byte) 0x27, (byte) 0xFF, (byte) 0x40, (byte) 0x5C, (byte) 0xEC,
			(byte) 0x8A, (byte) 0xA2, (byte) 0x0D, (byte) 0xDB, (byte) 0x16,
			(byte) 0x59, (byte) 0x95, (byte) 0x99, (byte) 0x4D, (byte) 0x11,
			(byte) 0xAC, (byte) 0xC5, (byte) 0x28, (byte) 0x73, (byte) 0x05,
			(byte) 0x49, (byte) 0x1B, (byte) 0x03, (byte) 0xA4, (byte) 0x43,
			(byte) 0x9F, (byte) 0x8F, (byte) 0x3A, (byte) 0x84, (byte) 0x08,
			(byte) 0x55, (byte) 0x08, (byte) 0xB3, (byte) 0xB2, (byte) 0xFE,
			(byte) 0x2F, (byte) 0xDD, (byte) 0x65, (byte) 0xE2, (byte) 0x98,
			(byte) 0x4F, (byte) 0xBF, (byte) 0x3A, (byte) 0xE7, (byte) 0xE3,
			(byte) 0x3D, (byte) 0xA8, (byte) 0x71, (byte) 0x7F, (byte) 0xDE,
			(byte) 0x99, (byte) 0x2F, (byte) 0xE2, (byte) 0xE6, (byte) 0x67,
			(byte) 0x7F, (byte) 0x9E, (byte) 0xFA, (byte) 0xDE, (byte) 0x7E,
			(byte) 0x60, (byte) 0xE2, (byte) 0xE4, (byte) 0x17, (byte) 0x10,
			(byte) 0xA1, (byte) 0x4B, (byte) 0xF4, (byte) 0x31, (byte) 0xD8,
			(byte) 0x5C, (byte) 0x88, (byte) 0x05, (byte) 0x7F, (byte) 0xD4,
			(byte) 0x38, (byte) 0x90, (byte) 0xF4, (byte) 0x72, (byte) 0x39,
			(byte) 0xA6, (byte) 0xA8, (byte) 0xA8, (byte) 0xA6, (byte) 0x4E,
			(byte) 0xF1, (byte) 0xD2, (byte) 0x6F, (byte) 0x63, (byte) 0x97,
			(byte) 0xDA, (byte) 0x9B};

	public PublicKey() {

		modulus = new byte[MODULUSLENGTH];
		apikey = (RSAPublicKey) KeyBuilder.buildKey(KeyBuilder.TYPE_RSA_PUBLIC,
				KeyBuilder.LENGTH_RSA_1024, false);
		Arrays.copy(defaultModulus, this.modulus);
		updateKey();

	}
	public PublicKey(byte[] modulus) {
		this();

		Arrays.copy(modulus, this.modulus);
		updateKey();

	}

	public boolean equals(PublicKey other) {
		return Arrays.equals(modulus, other.modulus)
				&& Arrays.equals(pubexponent, other.pubexponent);
	}

	public byte getCode() {
		return Code.PUBLICKEY;
	}

	public void copy(PublicKey p) {

		Arrays.copy(p.modulus, modulus);
		Arrays.copy(p.pubexponent, pubexponent);
		updateKey();

	}

	public boolean isPublicKey() {
		return true;
	}

	public void updateKey() {
		apikey.setExponent(pubexponent, (short) 0, EXPONENTLENGTH);
		apikey.setModulus(modulus, (short) 0, MODULUSLENGTH);
	}
	public javacard.security.Key toAPIKey() {
		return apikey;
	}

}
