package generated.ageVerification.javacard.ePa;

import javacard.framework.*;
import javacard.security.Signature;

public class SignedData implements Codeable, SignData {

	public byte[] signed;
	public static final short signedlength = 128; // ALG_RSA_SHA_PKCS1

	private static byte[] tmparray;

	private static Signature sig;

	public SignedData() {

		signed = new byte[Store.MAXSIGNEDLENGTH];
		tmparray = new byte[Store.MaxEncodingLengthSignData]; //length = max length of encoded SignData

	}

	public boolean equals(SignedData o) {

		return Arrays.equals(signed, o.signed);

	}

	public byte getCode() {
		return Code.SIGNEDDATA;
	}

	public void copy(SignedData o) {

		Arrays.copy(o.signed, signed);

	}

	// ********************************************************
	public static SignedData sign(PrivateKey key, SignData d) {

		if (sig == null)
			sig = Signature.getInstance(Signature.ALG_RSA_SHA_PKCS1, false);
		return Store.newSignedData().instSign(key, d);

	}

	public SignedData instSign(PrivateKey key, SignData d) {

		Coding.getInstance().encode(d, tmparray);
		short signlength = Coding.getInstance().getEncodingLength();

		sig.init(key.toAPIKey(), Signature.MODE_SIGN);
		sig.sign(tmparray, (short) 0, signlength, signed, (short) 0);

		return this;
	}
	// ********************************************************

	public static boolean verify(PublicKey key, SignedData sd, SignData s) {

		if (sig == null)
			sig = Signature.getInstance(Signature.ALG_RSA_SHA_PKCS1, false);

		return sd.verify(key, s);
	}

	public boolean verify(PublicKey key, SignData s) {
		if (!key.isPublicKey())

			SimpleComm.raiseError(); // or return null
		sig.init(key.toAPIKey(), Signature.MODE_VERIFY);
		Coding.getInstance().encode(s, tmparray);
		short signlength = Coding.getInstance().getEncodingLength();
		return sig.verify(tmparray, (short) 0, signlength, signed, (short) 0,
				signedlength);

	}
}
