package generated.ageVerification.terminal.terminal;

import java.math.BigInteger;
import java.security.spec.InvalidKeySpecException;
import java.security.*;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
@XmlAccessorType(XmlAccessType.FIELD)
public class PublicKey extends Key implements Codeable, SignData {

	public final static short MODULUSLENGTH = 128;
	public final static short EXPONENTLENGTH = 3;
	public final static String cryptProvider = "BC";

	private byte[] modulus;

	private byte[] pubexponent = {0x01, 0x00, 0x01};

	private static final byte[] defaultModulus = new byte[]{(byte) 0x95,
			(byte) 0x5D, (byte) 0x7D, (byte) 0x9F, (byte) 0xEB, (byte) 0x31,
			(byte) 0xFF, (byte) 0xBD, (byte) 0xBE, (byte) 0x0C, (byte) 0x1C,
			(byte) 0x5B, (byte) 0x53, (byte) 0x37, (byte) 0x1B, (byte) 0xBB,
			(byte) 0xDB, (byte) 0xFB, (byte) 0x7D, (byte) 0x83, (byte) 0x07,
			(byte) 0x41, (byte) 0x73, (byte) 0xE1, (byte) 0xDA, (byte) 0x82,
			(byte) 0x2F, (byte) 0x7A, (byte) 0xB6, (byte) 0x7B, (byte) 0xC9,
			(byte) 0x5D, (byte) 0x16, (byte) 0x52, (byte) 0xAE, (byte) 0xCD,
			(byte) 0x27, (byte) 0xFF, (byte) 0x40, (byte) 0x5C, (byte) 0xEC,
			(byte) 0x8A, (byte) 0xA2, (byte) 0x0D, (byte) 0xDB, (byte) 0x16,
			(byte) 0x59, (byte) 0x95, (byte) 0x99, (byte) 0x4D, (byte) 0x11,
			(byte) 0xAC, (byte) 0xC5, (byte) 0x28, (byte) 0x73, (byte) 0x05,
			(byte) 0x49, (byte) 0x1B, (byte) 0x03, (byte) 0xA4, (byte) 0x43,
			(byte) 0x9F, (byte) 0x8F, (byte) 0x3A, (byte) 0x84, (byte) 0x08,
			(byte) 0x55, (byte) 0x08, (byte) 0xB3, (byte) 0xB2, (byte) 0xFE,
			(byte) 0x2F, (byte) 0xDD, (byte) 0x65, (byte) 0xE2, (byte) 0x98,
			(byte) 0x4F, (byte) 0xBF, (byte) 0x3A, (byte) 0xE7, (byte) 0xE3,
			(byte) 0x3D, (byte) 0xA8, (byte) 0x71, (byte) 0x7F, (byte) 0xDE,
			(byte) 0x99, (byte) 0x2F, (byte) 0xE2, (byte) 0xE6, (byte) 0x67,
			(byte) 0x7F, (byte) 0x9E, (byte) 0xFA, (byte) 0xDE, (byte) 0x7E,
			(byte) 0x60, (byte) 0xE2, (byte) 0xE4, (byte) 0x17, (byte) 0x10,
			(byte) 0xA1, (byte) 0x4B, (byte) 0xF4, (byte) 0x31, (byte) 0xD8,
			(byte) 0x5C, (byte) 0x88, (byte) 0x05, (byte) 0x7F, (byte) 0xD4,
			(byte) 0x38, (byte) 0x90, (byte) 0xF4, (byte) 0x72, (byte) 0x39,
			(byte) 0xA6, (byte) 0xA8, (byte) 0xA8, (byte) 0xA6, (byte) 0x4E,
			(byte) 0xF1, (byte) 0xD2, (byte) 0x6F, (byte) 0x63, (byte) 0x97,
			(byte) 0xDA, (byte) 0x9B};

	public PublicKey() {

		Security.addProvider(new org.bouncycastle.jce.provider.BouncyCastleProvider());

		try {
			setKey(defaultModulus);
		} catch (Exception e) {

		}

	}
	public PublicKey(byte[] modulus) throws InvalidKeySpecException,
			NoSuchAlgorithmException, NoSuchProviderException {
		this();

		setKey(modulus);

	}

	public boolean equals(PublicKey other) {
		return Arrays.equals(modulus, other.modulus)
				&& Arrays.equals(pubexponent, other.pubexponent);
	}

	public byte getCode() {
		return Code.PUBLICKEY;
	}

	public void setKey(byte[] modulus) throws InvalidKeySpecException,
			NoSuchAlgorithmException, NoSuchProviderException {
		this.modulus = modulus.clone();
	}

	public void copy(PublicKey p) {

		if (p.getModulus() != null) {
			try {
				setKey(p.getModulus());
			} catch (InvalidKeySpecException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (NoSuchAlgorithmException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (NoSuchProviderException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

	}

	public boolean isPublicKey() {
		return true;
	}

	public java.security.PublicKey toAPIKey() throws Exception {
		BigInteger mod = new BigInteger(1, this.modulus);
		BigInteger pub = new BigInteger(1, this.pubexponent);
		KeyFactory rsakf = KeyFactory.getInstance("RSA", cryptProvider);
		java.security.PublicKey apikey = (java.security.PublicKey) rsakf
				.generatePublic(new java.security.spec.RSAPublicKeySpec(mod,
						pub));
		return apikey;
	}

	public byte[] getModulus() {
		return modulus;
	}

	public byte[] getPubexponent() {
		return pubexponent;
	}

}
